# Kubernetes 指南

Kubernetes 是谷歌开源的容器集群管理系统，是 Google 多年大规模容器管理技术 Borg 的开源版本，也是 CNCF 最重要的项目之一，主要功能包括：

- 基于容器的应用部署、维护和滚动升级
- 负载均衡和服务发现
- 跨机器和跨地区的集群调度
- 自动伸缩
- 无状态服务和有状态服务
- 广泛的 Volume 支持
- 插件机制保证扩展性

Kubernetes 发展非常迅速，已经成为容器编排领域的领导者。Kubernetes 的中文资料也非常丰富，但系统化和紧跟社区更新的则就比较少见了。《Kubernetes 指南》开源电子书旨在整理平时在开发和使用 Kubernetes 时的参考指南和实践总结，形成一个系统化的参考指南以方便查阅。欢迎大家关注和添加完善内容。

## 在线阅读

- 中文：[GitBook](https://kubernetes.feisky.xyz/zh/) [Github](https://github.com/feiskyer/kubernetes-handbook/blob/master/zh/SUMMARY.md) [InfoQ](http://www.infoq.com/cn/minibooks/Kubernetes-handbook)
- English：[GitBook](https://kubernetes.feisky.xyz/en/) [Github](https://github.com/feiskyer/kubernetes-handbook/blob/master/en/SUMMARY.md)

## 项目源码

项目源码存放于 Github 上，[https://github.com/feiskyer/kubernetes-handbook](https://github.com/feiskyer/kubernetes-handbook)。

### 本书版本更新记录

如无特殊说明，本指南所有文档仅适用于 Kubernetes v1.6 及以上版本。详细更新记录见 [CHANGELOG](https://github.com/feiskyer/kubernetes-handbook/blob/master/zh/CHANGELOG.md)。

## 微信公众号

扫码关注微信公众号，回复关键字即可在微信中查看相关章节。

<p align="center"> <img src="images/qrcode.jpg"></p>

## 贡献者

欢迎参与贡献和完善内容，贡献方法参考 [CONTRIBUTING](https://github.com/feiskyer/kubernetes-handbook/blob/master/CONTRIBUTING.md)。感谢所有的贡献者，贡献者列表见 [contributors](https://github.com/feiskyer/kubernetes-handbook/graphs/contributors)。
